<?php
class ControllerExtensionPaymentCashBill extends Controller {
	const OK_STATUS = "OK";

    public function index() {

		$data['button_confirm'] = $this->language->get('button_confirm');
		
		$this->load->model('checkout/order');
        $this->language->load('extension/payment/cashbill');

		$orderInfo = $this->model_checkout_order->getOrder($this->session->data['order_id']);
        $orderID = $this->session->data['order_id'];
        $secret = $this->config->get('payment_cashbill_secret');
        
		$data['clientData'] = array(
			'service'   => $this->config->get('payment_cashbill_pp'),
			'amount' 	=> $this->currency->format($orderInfo['total'], $orderInfo['currency_code'], $orderInfo['currency_value'], false),
			'desc' 		=> $this->language->get('payment_description').' ['.$orderID.']',
			'userdata'  => $orderID,
		    'ref'       => 'OpenCart-3',
			'forname'	=> $orderInfo['payment_firstname'],
			'surname'	=> $orderInfo['payment_lastname'],
			'email'		=> $orderInfo['email'],
			'tel'		=> $orderInfo['telephone'],
			'street'	=> $orderInfo['payment_address_1'],
			'street_n1'	=> $orderInfo['payment_address_2'],
			'street_n2'	=> '',
			'city'		=> $orderInfo['payment_city'],
			'postcode'	=> $orderInfo['payment_postcode'],
			'country'	=> $orderInfo['payment_country']
		);
		
		$data['signature'] = md5 ( implode("", $data['clientData']) . $secret );
		
		$message = 'Rozpoczęcie płatności dla zamówienia o nr. '.$orderID.' w serwisie CashBill';
		$this->model_checkout_order->addOrderHistory($orderID, $this->config->get('payment_cashbill_order_status_new_id'), $message, false);
		
        return $this->load->view('extension/payment/cashbill', $data);
    }

    public function callback() {

	    if (isset($_GET['userdata']) && $this->isRequestSignatureValid($_GET)){
	        if(strtoupper($_GET['status']) == self::OK_STATUS)
	        {
				$this->response->redirect($this->url->link('checkout/success'));
				return;
			}
			
	        $this->response->redirect($this->url->link('checkout/failure'));
	        return;
	    }
	    
	   if (isset($_POST['userdata']) && $this->isRequestSignatureValid($_POST)){
		   
	        $order_id = $_POST['userdata'];
	         
	        $this->load->model('checkout/order');
	
	        $order_info = $this->model_checkout_order->getOrder($order_id);
			$newOrderStatus = $this->config->get('payment_cashbill_order_status_cancel_id');
			$message = 'Klient anulował płatność za zamówienie.';

	        if(strtoupper($_POST['status']) == self::OK_STATUS){
	            $message = 'Płatność w kwocie '.$_POST['amount'].' zł została przyjęta przez CashBill. Identyfikator transakcji w systemie CashBill to '.$_POST['orderid'];
	            $newOrderStatus = $this->config->get('payment_cashbill_order_status_id');
			}
			
			if($order_info['order_status_id'] != $newOrderStatus){
				$this->model_checkout_order->addOrderHistory($order_id, $newOrderStatus, $message, false);
			}
						
	        exit("OK");
	    }
	    
	     $this->response->redirect($this->url->link('checkout/failure'));
	}

	private function isRequestSignatureValid($requestData){
		return $this->generateRequestSignature($requestData) == $requestData['sign']; 
	}

	private function generateRequestSignature($requestData){
		return md5($requestData['service'].$requestData['orderid'].$requestData['amount'].$requestData['userdata'].$requestData['status'].$this->config->get('payment_cashbill_secret'));
	}
	
}